# -*- coding: utf-8 -*-
# Copyright (C) 2019 fjord-technologies
# SPDX-License-Identifier: GPL-3.0-or-later
"""xtrargon_ng.classes.ec2"""

import logging

from .abstract.aws_boto3 import XtrargonAwsBoto3Base


LOG = logging.getLogger('xtrargon_ng.classes.ec2')


class XtrargonEc2Helper(XtrargonAwsBoto3Base): # pylint: disable-msg=useless-object-inheritance
    def __init__(self, config = None, client_cfg = None):

        XtrargonAwsBoto3Base.__init__(self, config, client_cfg)

    def boto3_client(self, service = 'ec2', event_hooks = None):
        return XtrargonAwsBoto3Base.boto3_client(self, service = service, event_hooks = event_hooks)

    @staticmethod
    def instance_info(data):
        r = {}

        for x in data['Reservations']:
            if not x or not x.get('Instances'):
                continue
            for y in x['Instances']:
                if not y.get('Tags'):
                    continue

                name = None
                for t in y['Tags']:
                    if t['Key'] == 'PrivateDnsName':
                        name = t['Value']
                        break

                if name:
                    r[name] = {'id': y['InstanceId'],
                               'state': y['State']['Name']}
                    break

        return r or None
